python unittest执行程序在pycharm可以成功运行但使用cmd会报错

如题,在pycharm中执行主程序运行成功:

已连接主机
登录成功
正在发送......
邮件发送完成~

Process finished with exit code 0

   在cmd执行主程序报错:

Traceback (most recent call last):
File"all_test.py",line 32,in
alltestnames = creatsuite()
File"all_test.py",line 27,in creatsuite
testunit.addTests(test_case)
File "C:\Python37\lib\unittest\suite.py",line57,in addTests
for test in tests:
TypeError:'_FailedTest'object is not iterable

报错的程序代码是这部分:

def creatsuite():

testunit = unittest.TestSuite()
test_dir = test_suite_dir
package_tests = unittest.defaultTestLoader.discover(test_dir,
                                                    pattern='*.py',
                                                    top_level_dir=None)
for test_suite in package_tests:
    for test_case in test_suite:
        testunit.addTests(test_case)
        print(testunit)
return testunit

刚接触接口测试,请问是哪里出了问题呢?因为正在jenkins构建项目执行,把源码放在github后使用windows批处理命令执行,这样进程是停滞的,也结束不了。

2个回答

楼主放错代码了吧,错误的是line57,in addTests
for test in tests:
但是代码没有这句

这个是由于缺少环境变量LD_LIBRARY_PATH
在终端查一下这个环境变量的值是多少,然后在jenkins上配置一下

Csdn user default icon
上传中...
上传图片
插入图片
抄袭、复制答案,以达到刷声望分或其他目的的行为,在CSDN问答是严格禁止的,一经发现立刻封号。是时候展现真正的技术了!
其他相关推荐
python--unittest测试运行成功没有出现句点,我用的pycharm

最开始我按照书上代码运行,显示Ran 0 tests in 0.000s,具体代码如下 (复制上来代码里很多缩进都没了,将就看下,代码是没有报错的,主要是测试有问题) 待测试代码: #name_function.py def get_formatted_name(first,last): '''piease enter your full name''' full_name = first + ' ' + last return full_name.title() 测试代码: import unittest from name_function import get_formatted_name class NameTestCase(unittest.TestCase): '''测试name_function.py''' def test_first_last_name(self): '''能否正确处理名字''' formatted_name = get_formatted_name('jian','ming') self.assertEqual(formatted_name,'Jian Ming') unittest.main() 运行结果: Launching unittests with arguments python -m unittest E:/python code/test_name_function.py in E:\python code ---------------------------------------------------------------------- Ran 0 tests in 0.000s OK Process finished with exit code 0 Empty test suite. 之后我在网上找到了两种解决方案 方案一: 将测试代码处的 unittest.main() 修改为 if __name__ == '__main__': unittest.main() 运行结果为 Launching unittests with arguments python -m unittest E:/python code/test_name_function.py in E:\python code Ran 1 test in 0.001s OK 没有句点,而书上运行结果如下,是有句点的 . ---------------------------------------------------------------------- Ran 1 test in 0.000s OK 方案二: 对get_formatted_name()进行测试 步骤如下: 选中该方法后ctrl+shift+T,如图 ![图片说明](https://img-ask.csdn.net/upload/201711/17/1510888257_266413.png) 选择creat New Test,选中该方法。测试代码如下 import unittest from name_function import get_formatted_name class NameTestCase(unittest.TestCase): '''测试name_function.py''' def test_first_last_name(self): '''能否正确处理名字''' formatted_name = get_formatted_name('jian','ming') self.assertEqual(formatted_name,'Jian Ming') 就是相比于书上代码,删掉了unittest.main() 运行结果同方案一,为什么会没有句点呢?

Python unittest中一个用例使用多套数据的情况怎么处理?

尝试在unittest中一个用例使用多套数据,代码如下,请高手指点一下: Data.py文件 ``` #coding=utf-8 adict = {"key1":"value1","key2":"value2","key3":"value3"} bdict = {"key1":"valuea","key2":"valueb","key3":"valuec"} ``` Case.py文件 ``` #coding=utf-8 import unittest,time import HTMLTestRunner import Data class MyTestCase(unittest.TestCase): dict = {} def SetData(dict): MyTestCase.dict = dict def testCase1(self): print self.dict["key1"] print self.dict["key2"] self.assertEqual("a","a") def testCase2(self): print self.dict["key1"] print self.dict["key2"] self.assertEqual("b","b") def Suite1(): suiteTest = unittest.TestSuite() MyTestCase.dict = Data.adict suiteTest.addTest(MyTestCase("testCase1")) suiteTest.addTest(MyTestCase("testCase2")) return suiteTest def Suite2(): suiteTest = unittest.TestSuite() MyTestCase.dict = Data.bdict suiteTest.addTest(MyTestCase("testCase1")) suiteTest.addTest(MyTestCase("testCase2")) return suiteTest if __name__ == '__main__': #确定生成报告的路径 suite = unittest.TestSuite((Suite1(),Suite2())) filePath = "D:/pyResult.html" fp = file(filePath,'wb') #生成报告的Title,描述 runner = HTMLTestRunner.HTMLTestRunner(stream=fp,title='Python Test Report',description='This is Python Report') runner.run(suite) fp.close() ``` 问题: 我在Suite1()和Suite2()中分别用了adict和bdict两组数据,但在报告中实际使用的都是bdict中的数据,不知道为啥啊,请高手指点一下,非常感谢。 ![图片说明](https://img-ask.csdn.net/upload/201706/17/1497698684_36033.jpg)

python3 unittest怎么做到上一个测试用例失败时自动跳过一下个测试用例

比如登录失败时,就跳过退出登录的用例,示例代码如下,大神求教,应该怎么写才能达到跳过的效果,如果使用@unittest.skipIf(),但是我怎么知道上个用例失败了呢 ``` import unittest class TestDemo(unittest.TestCase): @classmethod def setUpClass(cls): print("setupclass") def setUp(self): print("setup") def test_login(self): print("test_login") self.assertEqual(1, 2) # 这里让登录判断为失败 def test_logout(self): print("test_logout") def tearDown(self): print("teardown") @classmethod def tearDownClass(cls): print("teardownclass") if __name__ == "__main__": testsuite = unittest.TestSuite() testsuite.addTest(TestDemo("test_login")) testsuite.addTest(TestDemo("test_logout")) runner = unittest.TextTestRunner() runner.run(testsuite) ```

使用unittest框架编写的自动化测试代码,中在调用执行测试用例问题,急用

1、详细说明,有两个文件分别使用unittest单元测试框架编写了两个模块的用例,分别是登录成功模块,和登录成功后进行操作的模块。 2、在构造测试集的时候出现先一个想法,我想把登录成功用例作为登录成功后实行的操作功能的前置条件。 3、简述就是把一个文件中其中一个用例执行完成作为另外一个文件中的一个用例执行的前置条件,使用unittest框架怎么实现或python代码怎么实现。急用

python unittest 问题

import unittest, my_math class ProductTestCase(unittest.TestCase): def testInteger(self): for x in xrange(-10,10): for y in xrange(-10,10): p = my_math.product(x,y) self.failUnless(p ==x*y, 'Interger multi failed') def testFloats(self): for x in xrange(-10,10): for y in xrange(-10,10): x = x/10.0 y = y/10.0 p = my_math.product(x,y) self.failUnless(p ==x*y,'float multi failed') if __name__ == '__main__': unittest.main() 修改 def testFloats(self): 为 def tesrFloats(self): 为什么检测结果就变化。 前者检测到两个。后者仅仅检测到一个

unittest中的assertEqual代码为什么不被执行

import unittest from unit import hou class NamesTestCase(unittest.TestCase): def test_first_last_name(self): formatted_name = hou('janis', 'joplin') self.assertEqual(formatted_name,'Janis Joplin') unittest.main() 首先导入unittest,然后从unit文件导入hou函数 创建一个NamesTestCase类 创建一个test_first_last_name方法 新建一个变量formatted_name,值为将('janis','joplin') 使用assertEquql判断将值代入hou,函数后,结果是否为'janis joplin') 现在的情况 是使用代码调试功能,进行调试时,发现代码走到unittest.main()后不再往上走了,而是结束了,请明白的人告知,谢谢!加上if__name__=='__main__'时又可以运行,为什么不加这行又不可以。本人在初学python,看到书上的代码是没有if这个判断,也是可以运行的,我自己把代码复制过来,都运行不了。请问问题出在哪里了。是python版本的问题,求告知!

python 3.6 unittest没有testcase属性

python 3.6 unittest没有testcase属性![图片说明](https://img-ask.csdn.net/upload/201801/27/1517061590_384216.png)

python + unittest 通过读取excell文件中的数据进行接口的测试,每次执行一行

最近在做接口的测试,想通过读取excel里面的数据进行接口的测试,想达到的目标是,执行一次testcase,读取一行数据。在执行testcase的时候里面的参数通过读取Excel,将参数和断言赋值。 ``` class MyTestCase(unittest.TestCase): """ 每执行一次,读取excel一行数据,通过读取Excel的行数去确定执行的次数 """ @classmethod def setUpClass(cls) -> None: cls.service_name = "com.tz.course.stub.service.IServicePromiseFacadeAPI"# 通过读取Excel赋值 cls.method_name = "getServicePromise" #通过Excel赋值 def tearDownClass(cls) -> None: pass def test_errorIServicePromiseFacadeAPI(self): parm = "xyy" #通过读取excel进行赋值 oppen = RefundControl() result = oppen.request_Dubbo(self.service_name, self.method_name, parm) print("result:", result, type(result)) ass = '{"sucess": True}' #通过Excel赋值 # rsj = json.loads(result) # print("rsj类型:", rsj, type(rsj)) # results = rsj["results"] self.assertNotIn(ass, result) ``` 求大佬给个具体的样例参考一下。

python 使用unittest写脚本遇到的问题

![图片说明]![图片说明](https://img-ask.csdn.net/upload/201909/09/1567998684_245139.png) 如图所示的代码,会报错 AttributeError: 'TestKS' object has no attribute 'find_element_by_xpath' 但是如果将test_A的代码写到setUp那里,就不会如此了 请问,我应该怎么修改

怎么获得unittest返回值,也就是代码中的 return str

``` #-*- coding: UTF-8 -*- from threading import Timer import time from selenium import webdriver from nose_parameterized import parameterized import unittest class TestAdd(unittest.TestCase): def setUp(self): self.driver=webdriver.Chrome() self.driver.maximize_window() self.driver.get("http://www.juxiangyou.com") @parameterized.expand([ ('syt350964652@QQ.com'), ('syt350964653@QQ.com'), ]) def test_add(self,username): driver=self.driver driver.find_element_by_id('account').send_keys(username) time.sleep(5) driver.find_element_by_id('password').send_keys('111') time.sleep(11) driver.find_element_by_link_text('登 录').click() time.sleep(2) dqjb=self.driver.current_window_handle driver.find_element_by_link_text('匠神部落').click() time.sleep(2) list_jb=self.driver.window_handles for jb in list_jb: if jb!=dqjb: jb_two=jb driver.switch_to.window(jb_two) driver.find_element_by_id('forgeHall').click() time.sleep(2) time_num=self.driver.find_element_by_class_name('forge').text print(time_num[-8:]) str=time_num[-8:] return str def tearDown(self): self.driver.quit() if __name__=='__main__': unittest.main() ```

pycharm中如何设置让pytest只跑模块中的某一个方法?

请教pycharm中如何设置让pytest只跑模块中的某一个方法? class TestRun: def setup(self): self.driver = webdriver.Chrome() self.driver.get("www.xueqiu.com") def test_search_ibm(self): self.driver.find_element(By.ID, "tv_search").click() def test_home_swift(self): self.driver.find_element(By.ID, "search").click() 比如我只想让他跑test_home_swift(self): 这个方法。 工具和代码命令分别是怎么用?

pycharm工具中,鼠标右键运行Run调用了unnittest模块的python文件时候提示配置项目怎么解决?

![图片说明](https://img-ask.csdn.net/upload/202001/10/1578650379_247705.png) ![图片说明](https://img-ask.csdn.net/upload/202001/10/1578650385_597773.png) ![图片说明](https://img-ask.csdn.net/upload/202001/11/1578718472_580834.png) ![图片说明](https://img-ask.csdn.net/upload/202001/11/1578718496_393949.png)

unittest测试时,testsuite只能执行第一个用例,单独的用例都可以执行,这是为什么

代码为: class Count: def __init__(self,a,b): self.a = int(a) self.b = int(b) def add(self): return self.a + self.b from calculator import Count import unittest class TestCount(unittest.TestCase): def setUp(self): print('test start') def test_add(self): j = Count(2,3) self.assertEqual(j.add(),5) def test_add2(self): j = Count(41,76) self.assertEqual(j.add(),117) def tearDown(self): print('test end') if __name__ == "__main__": suite = unittest.TestSuite() suite.addTest(TestCount('test_add2')) suite.addTest(TestCount('test_add')) runner = unittest.TextTestRunner() runner.run(suite) 错误为: Traceback (most recent call last): File "<ipython-input-6-e4fc42a6bc0e>", line 1, in <module> runfile('E:/python-workspace/zidonghua/unittest/testsuite_texttestrunner_calculator.py', wdir='E:/python-workspace/zidonghua/unittest') File "C:\Users\liushu\Anaconda2\lib\site-packages\spyder\utils\site\sitecustomize.py", line 866, in runfile execfile(filename, namespace) File "C:\Users\liushu\Anaconda2\lib\site-packages\spyder\utils\site\sitecustomize.py", line 87, in execfile exec(compile(scripttext, filename, 'exec'), glob, loc) File "E:/python-workspace/zidonghua/unittest/testsuite_texttestrunner_calculator.py", line 34, in <module> runner.run(suite) File "C:\Users\liushu\Anaconda2\lib\unittest\runner.py", line 151, in run test(result) File "C:\Users\liushu\Anaconda2\lib\unittest\suite.py", line 70, in __call__ return self.run(*args, **kwds) File "C:\Users\liushu\Anaconda2\lib\unittest\suite.py", line 108, in run test(result) File "C:\Users\liushu\Anaconda2\lib\unittest\case.py", line 393, in __call__ return self.run(*args, **kwds) File "C:\Users\liushu\Anaconda2\lib\unittest\case.py", line 368, in run result.addSuccess(self) File "C:\Users\liushu\Anaconda2\lib\unittest\runner.py", line 63, in addSuccess self.stream.flush() IOError: [Errno 9] Bad file descriptor

请教下unittest源码中的这一句有什么作用?

在python的unittest库里,主要文件中都有这么一句: __unittest = True 全程没见在哪用到,哪位能帮忙看看这样的写法主要是什么作用呢? 找到了社区推荐的答案,谢谢各位: https://blog.csdn.net/nitibu/article/details/48392679

python单元测试总是没有发现测试

![图片说明](https://img-ask.csdn.net/upload/202003/08/1583642742_358747.jpg)![图片说明](https://img-ask.csdn.net/upload/202003/08/1583642748_611891.jpg)

求大神解决python,unittest测试结果为Ran 0 tests in 0.000s

testadd_run.py #coding=utf-8 import unittest from match_ import Match class Test_match(unittest.TestCase): def setUp(self): print("start test") def test_add(self): t = Match(3,4) add=t.add() self.assertEqual(add,7,msg="运行成功") print("case1") def test_add2(self): t = Match(5,4) add = t.add() self.assertEqual(add, 9, msg="运行失败") print("case2") def tearDown(self): print("test end") if __name__=="__main__": #unittest.main() suit=unittest.TestSuite suit.addTest(Test_match("test_add")) suit.addTest(Test_match("test_add2")) runner = unittest.TextTestRunner() runner.run(suit) testsub_run.py #coding=utf-8 import unittest from match_ import Match class TestMatchsub(unittest.TestCase): def setUp(self): print("test start:") def tearDown(self): print("test end") def test_sub(self): s=Match(6,2) aa=s.sub() self.assertEqual(aa,4) print("case 1 test_sub") def test_sub2(self): s=Match(1,3) aa=s.sub() self.assertEqual(aa,-2) print("case 2 test_sub2") if __name__=="__main__": #unittest.main() suit=unittest.TestSuite suit.addTest(TestMatchsub("test_sub")) suit.addTest(TestMatchsub("test_sub2")) runner=unittest.TextTestRunner() runner.run(suit) test_all.py import unittest test_dir = "./" dd=unittest.defaultTestLoader.discover(test_dir,pattern="*run.py") if __name__=="__main__": runner = unittest.TextTestRunner() runner.run(dd) match_.py from selenium import webdriver class Match(): def __init__(self,a,b): self.a=int(a) self.b=int(b) def add(self): su = self.a + self.b return su print(su) def sub(self): return self.a-self.b # if __name__=="__main__": # c=Match() # dd=c.add(2,3) # print(dd) 总是no tests 为什么啊

pycharm运行后显示Process finished with exit code 0

from __future__ import absolute_import from __future__ import division from __future__ import print_function import csv import os.path import time import numpy as np import tensorflow as tf import gpr import load_dataset import nngp tf.logging.set_verbosity(tf.logging.INFO) flags = tf.app.flags FLAGS = flags.FLAGS flags.DEFINE_string('hparams', '', 'Comma separated list of name=value hyperparameter pairs to' 'override the default setting.') flags.DEFINE_string('experiment_dir', '/tmp/nngp', 'Directory to put the experiment results.') flags.DEFINE_string('grid_path', 'pythonplace/nngp/grid_data', 'Directory to put or find the training data.') flags.DEFINE_integer('num_train', 1000, 'Number of training data.') flags.DEFINE_integer('num_eval', 1000, 'Number of evaluation data. Use 10_000 for full eval') flags.DEFINE_integer('seed', 1234, 'Random number seed for data shuffling') flags.DEFINE_boolean('save_kernel', False, 'Save Kernel do disk') flags.DEFINE_string('dataset', 'mnist', 'Which dataset to use ["mnist"]') flags.DEFINE_boolean('use_fixed_point_norm', False, 'Normalize input variance to fixed point variance') flags.DEFINE_integer('n_gauss', 501, 'Number of gaussian integration grid. Choose odd integer.') flags.DEFINE_integer('n_var', 501, 'Number of variance grid points.') flags.DEFINE_integer('n_corr', 500, 'Number of correlation grid points.') flags.DEFINE_integer('max_var', 100, 'Max value for variance grid.') flags.DEFINE_integer('max_gauss', 10, 'Range for gaussian integration.') def set_default_hparams(): return tf.contrib.training.HParams( nonlinearity='tanh', weight_var=1.3, bias_var=0.2, depth=2) def do_eval(sess, model, x_data, y_data, save_pred=False): """Run evaluation.""" gp_prediction, stability_eps = model.predict(x_data, sess) pred_1 = np.argmax(gp_prediction, axis=1) accuracy = np.sum(pred_1 == np.argmax(y_data, axis=1)) / float(len(y_data)) mse = np.mean(np.mean((gp_prediction - y_data)**2, axis=1)) pred_norm = np.mean(np.linalg.norm(gp_prediction, axis=1)) tf.logging.info('Accuracy: %.4f'%accuracy) tf.logging.info('MSE: %.8f'%mse) if save_pred: with tf.gfile.Open( os.path.join(FLAGS.experiment_dir, 'gp_prediction_stats.npy'), 'w') as f: np.save(f, gp_prediction) return accuracy, mse, pred_norm, stability_eps def run_nngp_eval(hparams, run_dir): """Runs experiments.""" tf.gfile.MakeDirs(run_dir) # Write hparams to experiment directory. with tf.gfile.GFile(run_dir + '/hparams', mode='w') as f: f.write(hparams.to_proto().SerializeToString()) tf.logging.info('Starting job.') tf.logging.info('Hyperparameters') tf.logging.info('---------------------') tf.logging.info(hparams) tf.logging.info('---------------------') tf.logging.info('Loading data') # Get the sets of images and labels for training, validation, and # # test on dataset. if FLAGS.dataset == 'mnist': (train_image, train_label, valid_image, valid_label, test_image, test_label) = load_dataset.load_mnist( num_train=FLAGS.num_train, mean_subtraction=True, random_roated_labels=False) else: raise NotImplementedError tf.logging.info('Building Model') if hparams.nonlinearity == 'tanh': nonlin_fn = tf.tanh elif hparams.nonlinearity == 'relu': nonlin_fn = tf.nn.relu else: raise NotImplementedError with tf.Session() as sess: # Construct NNGP kernel nngp_kernel = nngp.NNGPKernel( depth=hparams.depth, weight_var=hparams.weight_var, bias_var=hparams.bias_var, nonlin_fn=nonlin_fn, grid_path=FLAGS.grid_path, n_gauss=FLAGS.n_gauss, n_var=FLAGS.n_var, n_corr=FLAGS.n_corr, max_gauss=FLAGS.max_gauss, max_var=FLAGS.max_var, use_fixed_point_norm=FLAGS.use_fixed_point_norm) input("hello") # Construct Gaussian Process Regression model model = gpr.GaussianProcessRegression( train_image, train_label, kern=nngp_kernel) start_time = time.time() tf.logging.info('Training') # For large number of training points, we do not evaluate on full set to # save on training evaluation time. if FLAGS.num_train <= 5000: acc_train, mse_train, norm_train, final_eps = do_eval( sess, model, train_image[:FLAGS.num_eval], train_label[:FLAGS.num_eval]) tf.logging.info('Evaluation of training set (%d examples) took ' '%.3f secs'%( min(FLAGS.num_train, FLAGS.num_eval), time.time() - start_time)) else: acc_train, mse_train, norm_train, final_eps = do_eval( sess, model, train_image[:1000], train_label[:1000]) tf.logging.info('Evaluation of training set (%d examples) took ' '%.3f secs'%(1000, time.time() - start_time)) start_time = time.time() tf.logging.info('Validation') acc_valid, mse_valid, norm_valid, _ = do_eval( sess, model, valid_image[:FLAGS.num_eval], valid_label[:FLAGS.num_eval]) tf.logging.info('Evaluation of valid set (%d examples) took %.3f secs'%( FLAGS.num_eval, time.time() - start_time)) start_time = time.time() tf.logging.info('Test') acc_test, mse_test, norm_test, _ = do_eval( sess, model, test_image[:FLAGS.num_eval], test_label[:FLAGS.num_eval], save_pred=False) tf.logging.info('Evaluation of test set (%d examples) took %.3f secs'%( FLAGS.num_eval, time.time() - start_time)) metrics = { 'train_acc': float(acc_train), 'train_mse': float(mse_train), 'train_norm': float(norm_train), 'valid_acc': float(acc_valid), 'valid_mse': float(mse_valid), 'valid_norm': float(norm_valid), 'test_acc': float(acc_test), 'test_mse': float(mse_test), 'test_norm': float(norm_test), 'stability_eps': float(final_eps), } record_results = [ FLAGS.num_train, hparams.nonlinearity, hparams.weight_var, hparams.bias_var, hparams.depth, acc_train, acc_valid, acc_test, mse_train, mse_valid, mse_test, final_eps ] if nngp_kernel.use_fixed_point_norm: metrics['var_fixed_point'] = float(nngp_kernel.var_fixed_point_np[0]) record_results.append(nngp_kernel.var_fixed_point_np[0]) # Store data result_file = os.path.join(run_dir, 'results.csv') with tf.gfile.Open(result_file, 'a') as f: filewriter = csv.writer(f) filewriter.writerow(record_results) return metrics if __name__ == '__main__': # tf.app.run(main) hparams = set_default_hparams().parse(FLAGS.hparams) print("hparams:", hparams) x = FLAGS.experiment_dir print(x) run_nngp_eval(hparams, x)

unittest,selenium驱动浏览器的时候,浏览器只能打开一次是什么问题????、?

源码: ``` from selenium import webdriver driver=webdriver.Chrome() import unittest class Test_selenium(unittest.TestCase): def setUp(self) -> None: driver.get('https://cn.bing.com/') def tearDown(self) -> None: driver.quit() def test_add1(self): pass def test_add2(self): pass if __name__ == '__main__': unittest.main() ``` 报错信息 ``` Testing started at 20:40 ... E:\GitHub\Web_Framework\venv\Scripts\python.exe "E:\Program Files\JetBrains\PyCharm Community Edition 2019.2.5\helpers\pycharm\_jb_unittest_runner.py" --target test1.Test_selenium Launching unittests with arguments python -m unittest test1.Test_selenium in E:\GitHub\Python_Study\20200221 Error Traceback (most recent call last): File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connection.py", line 156, in _new_conn conn = connection.create_connection( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\util\connection.py", line 84, in create_connection raise err File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\util\connection.py", line 74, in create_connection sock.connect(sa) ConnectionRefusedError: [WinError 10061] 由于目标计算机积极拒绝,无法连接。 During handling of the above exception, another exception occurred: Traceback (most recent call last): File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 665, in urlopen httplib_response = self._make_request( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 387, in _make_request conn.request(method, url, **httplib_request_kw) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1230, in request self._send_request(method, url, body, headers, encode_chunked) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1276, in _send_request self.endheaders(body, encode_chunked=encode_chunked) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1225, in endheaders self._send_output(message_body, encode_chunked=encode_chunked) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 1004, in _send_output self.send(msg) File "E:\Program Files\Python\Python3.8\lib\http\client.py", line 944, in send self.connect() File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connection.py", line 184, in connect conn = self._new_conn() File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connection.py", line 168, in _new_conn raise NewConnectionError( urllib3.exceptions.NewConnectionError: <urllib3.connection.HTTPConnection object at 0x0000020FBA782100>: Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。 During handling of the above exception, another exception occurred: Traceback (most recent call last): File "E:\Program Files\Python\Python3.8\lib\unittest\case.py", line 60, in testPartExecutor yield File "E:\Program Files\Python\Python3.8\lib\unittest\case.py", line 672, in run self._callSetUp() File "E:\Program Files\Python\Python3.8\lib\unittest\case.py", line 630, in _callSetUp self.setUp() File "E:\GitHub\Python_Study\20200221\test1.py", line 8, in setUp driver.get('https://cn.bing.com/') File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\webdriver.py", line 333, in get self.execute(Command.GET, {'url': url}) File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\webdriver.py", line 319, in execute response = self.command_executor.execute(driver_command, params) File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\remote_connection.py", line 374, in execute return self._request(command_info[0], url, body=data) File "E:\Program Files\Python\Python3.8\lib\site-packages\selenium\webdriver\remote\remote_connection.py", line 397, in _request resp = self._conn.request(method, url, body=body, headers=headers) File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\request.py", line 79, in request return self.request_encode_body( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\request.py", line 171, in request_encode_body return self.urlopen(method, url, **extra_kw) File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\poolmanager.py", line 330, in urlopen response = conn.urlopen(method, u.request_uri, **kw) File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 747, in urlopen return self.urlopen( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 747, in urlopen return self.urlopen( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 747, in urlopen return self.urlopen( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\connectionpool.py", line 719, in urlopen retries = retries.increment( File "E:\Program Files\Python\Python3.8\lib\site-packages\urllib3\util\retry.py", line 436, in increment raise MaxRetryError(_pool, url, error or ResponseError(cause)) urllib3.exceptions.MaxRetryError: HTTPConnectionPool(host='127.0.0.1', port=13604): Max retries exceeded with url: /session/5a91f5a3ba7b7efd9309a569fffeeb9d/url (Caused by NewConnectionError('<urllib3.connection.HTTPConnection object at 0x0000020FBA782100>: Failed to establish a new connection: [WinError 10061] 由于目标计算机积极拒绝,无法连接。')) Assertion failed Ran 2 tests in 12.993s FAILED (errors=1) Process finished with exit code 1 Assertion failed Assertion failed ```

python3.0import argparse时报错

在pycharm中写了一个测试类,运行时报了如下的错误: D:\work\python\Python30\python.exe "D:\work\python\PyCharm\PyCharm Community Edition 2017.1.3\helpers\pycharm\_jb_unittest_runner.py" --path E:/py_file/untitled/test_byrrr.py Testing started at 19:40 ... Traceback (most recent call last): File "D:\work\python\PyCharm\PyCharm Community Edition 2017.1.3\helpers\pycharm\_jb_unittest_runner.py", line 10, in <module> path, targets, additional_args = jb_start_tests() File "D:\work\python\PyCharm\PyCharm Community Edition 2017.1.3\helpers\pycharm\_jb_runner_tools.py", line 374, in jb_start_tests _jb_utils.OptionDescription('--target', 'Python target to run', "append")) File "D:\work\python\PyCharm\PyCharm Community Edition 2017.1.3\helpers\pycharm\_jb_utils.py", line 124, in get_options import argparse ImportError: No module named argparse Process finished with exit code 1 贴个代码,希望有人能给解决一下: #!/usr/bin/env python #coding=utf8 class A(object): def getHa(self,string): print(string) if __name__=='__main__': a = A() a.getHa("hello.word")

大学四年自学走来,这些私藏的实用工具/学习网站我贡献出来了

大学四年,看课本是不可能一直看课本的了,对于学习,特别是自学,善于搜索网上的一些资源来辅助,还是非常有必要的,下面我就把这几年私藏的各种资源,网站贡献出来给你们。主要有:电子书搜索、实用工具、在线视频学习网站、非视频学习网站、软件下载、面试/求职必备网站。 注意:文中提到的所有资源,文末我都给你整理好了,你们只管拿去,如果觉得不错,转发、分享就是最大的支持了。 一、电子书搜索 对于大部分程序员...

在中国程序员是青春饭吗?

今年,我也32了 ,为了不给大家误导,咨询了猎头、圈内好友,以及年过35岁的几位老程序员……舍了老脸去揭人家伤疤……希望能给大家以帮助,记得帮我点赞哦。 目录: 你以为的人生 一次又一次的伤害 猎头界的真相 如何应对互联网行业的「中年危机」 一、你以为的人生 刚入行时,拿着傲人的工资,想着好好干,以为我们的人生是这样的: 等真到了那一天,你会发现,你的人生很可能是这样的: ...

程序员请照顾好自己,周末病魔差点一套带走我。

程序员在一个周末的时间,得了重病,差点当场去世,还好及时挽救回来了。

技术大佬:我去,你写的 switch 语句也太老土了吧

昨天早上通过远程的方式 review 了两名新来同事的代码,大部分代码都写得很漂亮,严谨的同时注释也很到位,这令我非常满意。但当我看到他们当中有一个人写的 switch 语句时,还是忍不住破口大骂:“我擦,小王,你丫写的 switch 语句也太老土了吧!” 来看看小王写的代码吧,看完不要骂我装逼啊。 private static String createPlayer(PlayerTypes p...

和黑客斗争的 6 天!

互联网公司工作,很难避免不和黑客们打交道,我呆过的两家互联网公司,几乎每月每天每分钟都有黑客在公司网站上扫描。有的是寻找 Sql 注入的缺口,有的是寻找线上服务器可能存在的漏洞,大部分都...

点沙成金:英特尔芯片制造全过程揭密

“亚马逊丛林里的蝴蝶扇动几下翅膀就可能引起两周后美国德州的一次飓风……” 这句人人皆知的话最初用来描述非线性系统中微小参数的变化所引起的系统极大变化。 而在更长的时间尺度内,我们所生活的这个世界就是这样一个异常复杂的非线性系统…… 水泥、穹顶、透视——关于时间与技艺的蝴蝶效应 公元前3000年,古埃及人将尼罗河中挖出的泥浆与纳特龙盐湖中的矿物盐混合,再掺入煅烧石灰石制成的石灰,由此得来了人...

讲一个程序员如何副业月赚三万的真实故事

loonggg读完需要3分钟速读仅需 1 分钟大家好,我是你们的校长。我之前讲过,这年头,只要肯动脑,肯行动,程序员凭借自己的技术,赚钱的方式还是有很多种的。仅仅靠在公司出卖自己的劳动时...

上班一个月,后悔当初着急入职的选择了

最近有个老铁,告诉我说,上班一个月,后悔当初着急入职现在公司了。他之前在美图做手机研发,今年美图那边今年也有一波组织优化调整,他是其中一个,在协商离职后,当时捉急找工作上班,因为有房贷供着,不能没有收入来源。所以匆忙选了一家公司,实际上是一个大型外包公司,主要派遣给其他手机厂商做外包项目。**当时承诺待遇还不错,所以就立马入职去上班了。但是后面入职后,发现薪酬待遇这块并不是HR所说那样,那个HR自...

女程序员,为什么比男程序员少???

昨天看到一档综艺节目,讨论了两个话题:(1)中国学生的数学成绩,平均下来看,会比国外好?为什么?(2)男生的数学成绩,平均下来看,会比女生好?为什么?同时,我又联想到了一个技术圈经常讨...

副业收入是我做程序媛的3倍,工作外的B面人生是怎样的?

提到“程序员”,多数人脑海里首先想到的大约是:为人木讷、薪水超高、工作枯燥…… 然而,当离开工作岗位,撕去层层标签,脱下“程序员”这身外套,有的人生动又有趣,马上展现出了完全不同的A/B面人生! 不论是简单的爱好,还是正经的副业,他们都干得同样出色。偶尔,还能和程序员的特质结合,产生奇妙的“化学反应”。 @Charlotte:平日素颜示人,周末美妆博主 大家都以为程序媛也个个不修边幅,但我们也许...

MySQL数据库面试题(2020最新版)

文章目录数据库基础知识为什么要使用数据库什么是SQL?什么是MySQL?数据库三大范式是什么mysql有关权限的表都有哪几个MySQL的binlog有有几种录入格式?分别有什么区别?数据类型mysql有哪些数据类型引擎MySQL存储引擎MyISAM与InnoDB区别MyISAM索引与InnoDB索引的区别?InnoDB引擎的4大特性存储引擎选择索引什么是索引?索引有哪些优缺点?索引使用场景(重点)...

如果你是老板,你会不会踢了这样的员工?

有个好朋友ZS,是技术总监,昨天问我:“有一个老下属,跟了我很多年,做事勤勤恳恳,主动性也很好。但随着公司的发展,他的进步速度,跟不上团队的步伐了,有点...

我入职阿里后,才知道原来简历这么写

私下里,有不少读者问我:“二哥,如何才能写出一份专业的技术简历呢?我总感觉自己写的简历太烂了,所以投了无数份,都石沉大海了。”说实话,我自己好多年没有写过简历了,但我认识的一个同行,他在阿里,给我说了一些他当年写简历的方法论,我感觉太牛逼了,实在是忍不住,就分享了出来,希望能够帮助到你。 01、简历的本质 作为简历的撰写者,你必须要搞清楚一点,简历的本质是什么,它就是为了来销售你的价值主张的。往深...

我说我不会算法,阿里把我挂了。

不说了,字节跳动也反手把我挂了。

优雅的替换if-else语句

场景 日常开发,if-else语句写的不少吧??当逻辑分支非常多的时候,if-else套了一层又一层,虽然业务功能倒是实现了,但是看起来是真的很不优雅,尤其是对于我这种有强迫症的程序"猿",看到这么多if-else,脑袋瓜子就嗡嗡的,总想着解锁新姿势:干掉过多的if-else!!!本文将介绍三板斧手段: 优先判断条件,条件不满足的,逻辑及时中断返回; 采用策略模式+工厂模式; 结合注解,锦...

离职半年了,老东家又发 offer,回不回?

有小伙伴问松哥这个问题,他在上海某公司,在离职了几个月后,前公司的领导联系到他,希望他能够返聘回去,他很纠结要不要回去? 俗话说好马不吃回头草,但是这个小伙伴既然感到纠结了,我觉得至少说明了两个问题:1.曾经的公司还不错;2.现在的日子也不是很如意。否则应该就不会纠结了。 老实说,松哥之前也有过类似的经历,今天就来和小伙伴们聊聊回头草到底吃不吃。 首先一个基本观点,就是离职了也没必要和老东家弄的苦...

为什么你不想学习?只想玩?人是如何一步一步废掉的

不知道是不是只有我这样子,还是你们也有过类似的经历。 上学的时候总有很多光辉历史,学年名列前茅,或者单科目大佬,但是虽然慢慢地长大了,你开始懈怠了,开始废掉了。。。 什么?你说不知道具体的情况是怎么样的? 我来告诉你: 你常常潜意识里或者心理觉得,自己真正的生活或者奋斗还没有开始。总是幻想着自己还拥有大把时间,还有无限的可能,自己还能逆风翻盘,只不是自己还没开始罢了,自己以后肯定会变得特别厉害...

男生更看重女生的身材脸蛋,还是思想?

往往,我们看不进去大段大段的逻辑。深刻的哲理,往往短而精悍,一阵见血。问:产品经理挺漂亮的,有点心动,但不知道合不合得来。男生更看重女生的身材脸蛋,还是...

为什么程序员做外包会被瞧不起?

二哥,有个事想询问下您的意见,您觉得应届生值得去外包吗?公司虽然挺大的,中xx,但待遇感觉挺低,马上要报到,挺纠结的。

当HR压你价,说你只值7K,你该怎么回答?

当HR压你价,说你只值7K时,你可以流畅地回答,记住,是流畅,不能犹豫。 礼貌地说:“7K是吗?了解了。嗯~其实我对贵司的面试官印象很好。只不过,现在我的手头上已经有一份11K的offer。来面试,主要也是自己对贵司挺有兴趣的,所以过来看看……”(未完) 这段话主要是陪HR互诈的同时,从公司兴趣,公司职员印象上,都给予对方正面的肯定,既能提升HR的好感度,又能让谈判气氛融洽,为后面的发挥留足空间。...

面试:第十六章:Java中级开发(16k)

HashMap底层实现原理,红黑树,B+树,B树的结构原理 Spring的AOP和IOC是什么?它们常见的使用场景有哪些?Spring事务,事务的属性,传播行为,数据库隔离级别 Spring和SpringMVC,MyBatis以及SpringBoot的注解分别有哪些?SpringMVC的工作原理,SpringBoot框架的优点,MyBatis框架的优点 SpringCould组件有哪些,他们...

面试阿里p7,被按在地上摩擦,鬼知道我经历了什么?

面试阿里p7被问到的问题(当时我只知道第一个):@Conditional是做什么的?@Conditional多个条件是什么逻辑关系?条件判断在什么时候执...

你打算用Java 8一辈子都不打算升级到Java 14,真香

我们程序员应该抱着尝鲜、猎奇的心态,否则就容易固步自封,技术停滞不前。

无代码时代来临,程序员如何保住饭碗?

编程语言层出不穷,从最初的机器语言到如今2500种以上的高级语言,程序员们大呼“学到头秃”。程序员一边面临编程语言不断推陈出新,一边面临由于许多代码已存在,程序员编写新应用程序时存在重复“搬砖”的现象。 无代码/低代码编程应运而生。无代码/低代码是一种创建应用的方法,它可以让开发者使用最少的编码知识来快速开发应用程序。开发者通过图形界面中,可视化建模来组装和配置应用程序。这样一来,开发者直...

面试了一个 31 岁程序员,让我有所触动,30岁以上的程序员该何去何从?

最近面试了一个31岁8年经验的程序猿,让我有点感慨,大龄程序猿该何去何从。

大三实习生,字节跳动面经分享,已拿Offer

说实话,自己的算法,我一个不会,太难了吧

程序员垃圾简历长什么样?

已经连续五年参加大厂校招、社招的技术面试工作,简历看的不下于万份 这篇文章会用实例告诉你,什么是差的程序员简历! 疫情快要结束了,各个公司也都开始春招了,作为即将红遍大江南北的新晋UP主,那当然要为小伙伴们做点事(手动狗头)。 就在公众号里公开征简历,义务帮大家看,并一一点评。《启舰:春招在即,义务帮大家看看简历吧》 一石激起千层浪,三天收到两百多封简历。 花光了两个星期的所有空闲时...

《经典算法案例》01-08:如何使用质数设计扫雷(Minesweeper)游戏

我们都玩过Windows操作系统中的经典游戏扫雷(Minesweeper),如果把质数当作一颗雷,那么,表格中红色的数字哪些是雷(质数)?您能找出多少个呢?文中用列表的方式罗列了10000以内的自然数、质数(素数),6的倍数等,方便大家观察质数的分布规律及特性,以便对算法求解有指导意义。另外,判断质数是初学算法,理解算法重要性的一个非常好的案例。

《Oracle Java SE编程自学与面试指南》最佳学习路线图(2020最新版)

正确选择比瞎努力更重要!

一文带你入门Java Stream流,太强了

两个星期以前,就有读者强烈要求我写一篇 Java Stream 流的文章,我说市面上不是已经有很多了吗,结果你猜他怎么说:“就想看你写的啊!”你看你看,多么苍白的喜欢啊。那就“勉为其难”写一篇吧,嘻嘻。 单从“Stream”这个单词上来看,它似乎和 java.io 包下的 InputStream 和 OutputStream 有些关系。实际上呢,没毛关系。Java 8 新增的 Stream 是为...

立即提问
相关内容推荐